package edu.wisc.my.root;

import java.io.IOException;
import java.io.InputStream;
import java.io.Writer;
import java.util.Scanner;

import org.apache.catalina.Valve;
import org.apache.catalina.connector.Request;
import org.apache.catalina.connector.Response;
import org.apache.catalina.util.RequestUtil;
import org.apache.catalina.valves.Constants;
import org.apache.catalina.valves.ErrorReportValve;
import org.apache.tomcat.util.res.StringManager;


public class MyUWErrorValve extends ErrorReportValve implements Valve {
  
  private static String ERROR_PAGE_LOCATION="/500.html";
  private static String MISSING_PAGE_LOCATION="/404.html";
  
  @Override
  protected void report(Request request, Response response, Throwable throwable) {
    int statusCode = response.getStatus();

    // Do nothing on a 1xx, 2xx and 3xx status
    // Do nothing if anything has been written already
    // Do nothing if the response hasn't been explicitly marked as in error
    //    and that error has not been reported.
    if (statusCode < 400 || response.getContentWritten() > 0 || !response.setErrorReported()) {
        return;
    }
    
    try {
      if(statusCode > 400 && statusCode < 500)
        response.sendRedirect(MISSING_PAGE_LOCATION);
      else 
        response.sendRedirect(ERROR_PAGE_LOCATION);
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
}